﻿--[[
	This file is part of PlayerZone AddOn for WoW 3.3.5a
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	
	Copyright © 2017 Yulemath
]]
local PlayerZone = LibStub("AceAddon-3.0"):GetAddon("PlayerZone")
local L = LibStub("AceLocale-3.0"):GetLocale("PlayerZone")

function PlayerZone:WorldMapUpdate()
	if ( not WorldMapFrame:IsShown() ) then return end
	local f, f2, db = WorldMapButton, PlayerZoneWMIFrame, PlayerZoneData
	local x, y = GetCursorPosition()
	x = x / f:GetEffectiveScale()
	y = y / f:GetEffectiveScale()

	local centerX, centerY = f:GetCenter()
	local width = f:GetWidth()
	local height = f:GetHeight()
	local adjustedY = (centerY + (height/2) - y ) / height
	local adjustedX = (x - (centerX - (width/2))) / width
	
	if ( f:IsMouseOver() ) then
	local name, fileName, texPercentageX, texPercentageY, textureX, textureY, scrollChildX, scrollChildY = UpdateMapHighlight( adjustedX, adjustedY )
		PlayerZoneWMBText:SetText(name)
		PlayerZoneWMBText:SetFont("Interface\\AddOns\\PlayerZone\\Fonts\\BlackChancery.ttf", 32, "")
		WorldMapFrameAreaLabel:SetText("")
		if ( not fileName or fileName == "Kalimdor" or fileName == "Northrend" or fileName == "Azeroth" ) then
			f2:Hide()
		else
			if ( db.wmS ) then
				f2:Show()
				self:GetMapHighlight(fileName)
			end
		end
	end
end

function PlayerZone:GetMapHighlight(filename)
local text, f, instance, raid
local datas = {}
local i = string.lower(filename)
self:DeleteFrame(PlayerZoneInstanceHeader)
self:DeleteFrame(PlayerZoneInstanceBody)
self:DeleteFrame(PlayerZoneRaidHeader)
self:DeleteFrame(PlayerZoneRaidBody)

datas = {

	--Usage of datas : {"name of mousover region",level min,level max,{'dungeons datas' (if exist)},{'raid datas' (if exist)},
	
	--Usage of dungeons datas : {"dungeon name",level min,level max,if heroic mode (bool),level min heroic mode}
	
	--Usage of raid datas : {"raid name",level range,number of players (string),if heroic mod (bool),difficulty range (0 - 5),old raid flag (bool, for 20 - 40 men)}
	
	-- Kalimdor
	{"teldrassil",1,10},
	{"azuremystisle",1,10},
	{"bloodmystisle",20,30},
	{"darkshore",10,20},
	{"felwood",48,55},
	{"moonglade",10,70},
	{"winterspring",55,60},
	{"aszhara",45,55},
	{"durotar",1,10},
	{"barrens",10,20,
	 {
	   {L["waillingcaverns"],15,22,false},
	   {L["razorfenkraul"],25,35,false},
	   {L["razorfendowns"],35,44,false}
	 },
	 {
	   {""}
	 }
	},
	{"ashenvale",18,30,
	 {
	   {L["blackfathomdeeps"],20,27,false}
	 },
	 {
	   {""}
	 }
	},
	{"stonetalonmountains",15,27},
	{"mulgore",1,10},
	{"desolace",30,40,
	 {
	   {L["maraudon"],45,54,false}
	 },
	 {
	   {""}
	 }
	},
	{"feralas",45,50,
	 {
	   {L["diremaul : warpwoodquarter"],36,46,false},
	   {L["diremaul : capitalgardens"],39,49,false},
	   {L["diremaul : gordokcommons"],42,52,false}
	 },
	 {
	   {""}
	 }
	},
	{"dustwallow",35,45,
	 {
	   {""}
	 },
	 {
	   {L["onyxialair"],80,"10 - 25",false,3}
	 }
	},
	{"thousandneedles",25,35},
	{"tanaris",40,50,
	 {
	   {L["zulfarrak"],43,50,false},
	   {L["gt1"],66,68,true,70},
	   {L["gt2"],68,70,true,70},
	   {L["gt4"],78,80,true,80}
	 },
	 {
	   {L["gt3"],70,"25",false,1}
	 }
	},
	{"ungorocrater",48,55},
	{"silithus",55,60,
	 {
	   {""}
	 },
	 {
	   {L["ruinsofahnqiraj"],60,"20",false,1},
	   {L["templeofahnqiraj"],60,"40",false,1}
	 }
	},
	{"darnassis",0,0},
	{"theexodar",0,0},
	{"ogrimmar",0,0,
	 {
	   {L["ragefire"],13,16,false}
	 },
	 {
	   {""}
	 }
	},
	{"thunderbluff",0,0},
	-- Eastern Kingdoms
	{"sunwell",68,70,
	 {
	   {L["magisterterrace"],68,70,false}
	 },
	 {
	   {L["sunwellplateau"],70,"25",false,1}
	 }
	},
	{"eversongwoods",1,10},
	{"ghostlands",10,20,
	 {
	   {""}
	 },
	 {
	   {L["zulaman"],70,"10",false,1}
	 }
	},
	{"easternplaguelands",53,60,
	 {
	   {L["stratholme"],55,60,false}
	 },
	 {
	   {""}
	 }
	},
	{"westernplaguelands",51,58,
	 {
	   {L["scholomance"],58,60,false}
	 },
	 {
	   {""}
	 }
	},
	{"tirisfal",1,10,
	 {
	   {L["scarletmonastery : graveyard"],30,32,false},
	   {L["scarletmonastery : library"],33,35,false},
	   {L["scarletmonastery : armory"],35,37,false},
	   {L["scarletmonastery : cathedral"],36,40,false}
	 },
	 {
	   {""}
	 }
	},
	{"silverpine",10,20,
	 {
	   {L["shadowfangkeep"],18,26,false}
	 },
	 {
	   {""}
	 }
	},
	{"hilsbrad",20,30},
	{"alterac",25,40},
	{"arathi",30,40},
	{"hinterlands",40,50},
	{"wetlands",20,30},
	{"lochmodan",10,20},
	{"dunmorogh",1,10,
	 {
	   {L["gnomeregan"],28,35,false}
	 },
	 {
	   {""}
	 }
	},
	{"badlands",35,45,
	 {
	   {L["uldaman"],35,45,false}
	 },
	 {
	   {""}
	 }
	},
	{"searinggorge",43,50},
	{"burningsteppes",50,58,
	 {
	   {L["blackrockmountain : blackrockdepths"],52,60,false},
	   {L["blackrockmountain : lowerblackrockspire"],55,60,false},
	   {L["blackrockmountain : upperblackrockspire"],55,60,false}
	 },
	 {
	   {L["blackroclmountain : moltencore"],60,"40",false,1},
	   {L["blackrockmountain : blackwinglair"],60,"40",false,1}
	 }
	},
	{"redridge",15,20},
	{"elwynn",1,10},
	{"westfall",10,20,
	 {
	   {L["deadmines"],15,22,false}
	 },
	 {
	   {""}
	 }
	},
	{"duskwood",18,30},
	{"deadwindpass",55,60,
	 {
	   {""}
	 },
	 {
	   {"Karazhan",70,"25",false,0}
	 }
	},
	{"swampofsorrows",35,45,
	 {
	   {L["sunkentemple"],45,55,false}
	 },
	 {
	   {""}
	 }
	},
	{"blastedlands",45,55},
	{"stranglethorn",30,45,
	 {
	   {""}
	 },
	 {
	   {L["zulgurub"],60,"20",false,1}
	 }
	},
	{"silvermooncity",0,0},
	{"undercity",0,0},
	{"ironforge",0,0},
	{"stormwind",0,0,
	 {
	   {L["stockade"],20,29,false}
	 },
	 {
	   {""}
	 }
	},
	-- Outland
	{"shattrathcity",0,0},
	{"hellfire",58,63,
	 {
	   {L["hellfireremparts"],57,67,true,70},
	   {L["bloodfurnace"],58,68,true,70},
	   {L["shatteredhalls"],65,70,true,70}
	 },
	 {
	   {L["magtheridon"],70,"25",false,2}
	 }
	},
	{"terokkarforest",62,65,
	 {
	   {L["manatombs"],61,70,true,70},
	   {L["auchenaicrypts"],62,70,true,70},
	   {L["sethekkhalls"],63,70,true,70},
	   {L["shadowlabyrinth"],65,70,true,70}
	 },
	 {
	   {""}
	 }
	},
	{"shadowmoonvalley",67,70,
	 {
	   {""}
	 },
	 {
	   {L["blacktemple"],70,"25",false,1}
	 }
	},
	{"nagrand",64,67},
	{"zangarmarsh",60,64,
	 {
	   {L["slavepens"],59,69,true,70},
	   {L["underblog"],60,70,true,70},
	   {L["steamvault"],61,70,true,70}
	 },
	 {
	   {L["serpentshrinecavern"],70,"25",false,1}
	 }
	},
	{"bladesedgemountains",65,68,
	 {
	   {""},
	 },
	 {
	   {L["gruulslair"],70,"25",false,1}
	 }
	},
	{"expansion01",0,0},
	{"netherstorm",65,68,
	 {
	   {L["mechanar"],67,70,true,70},
	   {L["botanica"],67,70,true,70},
	   {L["arcatraz"],68,70,true,70}
	 },
	 {
	   {L["theeye"],70,"25",false,1}
	 }
	},
	-- Northend
	{"dalaran",0,0},
	{"crystalsongforest",77,80,
		{
			{L["dalaran : violethold"],72,77,true,80}
		},
		{
		{""}
		}
	},
	{"icecrownglacier",77,80,
		{
			{L["forgeofsouls"],75,80,true,80},
			{L["pitofsaron"],75,80,true,80},
			{L["hallsofreflection"],75,80,true,80},
			{L["trialofthechampion"],75,80,true,80}
		},
		{
			{L["icecrowncitadel"],80,"10 - 25",true,5},
			{L["trialofthecrusader"],80,"10 - 25",true,4}
		},
	},
	{"sholazarbasin",76,78},
	{"lakewintergrasp",77,80,
	  {
		  {""},
	  },
		{
			{L["vaultofarchavon"],80,"10 - 25",false,2}
		}
	},
	{"boreantundra",68,72,
		{
			{L["nexus"],68,73,true,80},
			{L["occulus"],75,80,true,80},
		},
		{
		  {L["eyeofeternity"],80,"10 - 25",false,4}
		}
	},
	{"dragonblight",71,74,
		{
			{L["azjol-nerub"],69,74,true,80},
			{L["ahnkahet"],70,75,true,80}
		},
		{
			{L["naxxramas"],80,"10 - 25",false,4},
			{L["sanctumobsidian"],80,"10 - 25",false,3},
			{L["sanctumruby"],80,"10 - 25",true,5}
		}
	},
	{"howlingfjord",68,72,
		{
			{L["utgardekeep"],67,72,true,80},
			{L["utgardepinnacle"],75,80,true,80}
		},
		{
		{""},
		}
	},
	{"grizzlyhills",73,75},
	{"zuldrak",74,77,
		{
			{L["Draktharonkeep"],71,76,true,80},
			{L["Gundrak"],73,78,true,80}
		},
		{
		{""}
		}
	},
	{"thestormpeaks",77,80,
		{
			{L["hallsofstone"],74,79,true,80},
			{L["hallsoflightning"],75,80,true,80}
		},
		{
			{L["ulduar"],80,"10 - 25",false,5,0}
		}
	},
	{"hrothgarslanding",77,80}
}

local w1, w2, w
for k, v in pairs(datas) do
	if ( v[1] == i ) then
		if ( v[4] and v[4][1][1] ~= "" ) then
			w1 = 0
			f = "Instance"
			local h = 0
			self:CreateInstanceFrame(f)
			for key, val in pairs(v[4]) do
				h, y = self:InstanceFontString(key, val[1], val[2], val[3], val[4], val[5], PlayerZoneInstanceBody)
				h = y + h + 12
			end
			PlayerZoneInstanceBody:SetHeight(h)
			w1 = PlayerZoneInstanceBody:GetWidth()
		end
		if ( v[5] and v[5][1][1] ~= "" ) then
			w2 = 0
			f = "Raid"
			local h = 0
			self:CreateInstanceFrame(f)
			for key, val in pairs(v[5]) do
				h, y = self:RaidFontString(key, val[1], val[2], val[3], val[4], val[5], PlayerZoneRaidBody)
				h = y + h + 12
			end
			PlayerZoneRaidBody:SetHeight(h)
			w2 = PlayerZoneRaidBody:GetWidth()
		end
		local player, lvlLess, fS = UnitLevel("player"), (v[3] + 2), PlayerZoneFootText	
		if ( player >= lvlLess ) then
			fS:SetTextColor(0.4, 0.4, 0.4)
		elseif ( player >= v[3] and player < lvlLess ) then
			fS:SetTextColor(0, 1, 0)
		elseif ( player < v[3] and player > v[2] ) then
			fS:SetTextColor(1, 1, 0)
		elseif ( player == v[2] ) then
			fS:SetTextColor(1, 0.3, 0.3)
		elseif ( player < v[2] ) then
			fS:SetTextColor(0.7, 0, 0)
		end
		fS:SetText(L["|cffffffffNiveau : |r"]..v[2].." - "..v[3])
		if ( v[2] == 0 and v[3] == 0 ) then
			fS:SetText(L["Capitale"])
			fS:SetTextColor(0, 0.5, 1)
			end
		end
end

if ( not w1 and w2 ) then
	w = w2
elseif ( not w2 and w1 ) then
	w = w1
elseif ( not w1 and not w2 ) then
	w = PlayerZoneFrameFoot:GetWidth()
elseif ( w1 > w2 ) then
	w = w1
else
	w = w2
end
local H

if ( not PlayerZoneRaidHeader and not PlayerZoneInstanceHeader ) then
	H = PlayerZoneFrameFoot:GetHeight()
elseif ( not PlayerZoneInstanceHeader ) then 
H = PlayerZoneRaidHeader:GetHeight() + PlayerZoneRaidBody:GetHeight() + PlayerZoneFrameFoot:GetHeight()
elseif ( not PlayerZoneRaidHeader ) then
H = PlayerZoneInstanceHeader:GetHeight() + PlayerZoneInstanceBody:GetHeight() + PlayerZoneFrameFoot:GetHeight()
else
H = PlayerZoneInstanceHeader:GetHeight() + PlayerZoneInstanceBody:GetHeight() + PlayerZoneRaidHeader:GetHeight() + PlayerZoneRaidBody:GetHeight() + PlayerZoneFrameFoot:GetHeight()
end
PlayerZoneWMIFrame:SetHeight(H)
PlayerZoneWMIFrame:SetWidth(w)
PlayerZoneFrameFoot:SetPoint("BOTTOM", PlayerZoneWMIFrame, "BOTTOM")
datas = {}
end

